var Slider = function (parentScroll, scroll, content) {
    this.parentScroll=parentScroll;
    this.scroll=scroll;
    this.content=content;
    this.init();
}
Slider.prototype = {
    difference:4,
    totalHeight: function () {
        return this.content[0].scrollHeight;
    },
    height: function () {
        return $(this.content).height();
    },
    scrollHeight:function(){
        return this.height()-this.difference;
    },
    maxOffset: function () {
        return this.totalHeight() - this.height() + 10;
    },
    
    init: function () {
        // set the size of the scrollbar
        $(this.parentScroll).height(this.content.height());
    
        $(this.scroll).slider({
            "orientation": "vertical",
            "slide": function (event, ui) {
                slider.content.css("margin-top", Math.round((ui.value - 100) * slider.maxOffset() / 100));
            }
        });
    },
    
    // (show the slider ?) and  set the size of the handle
    resize: function () {
        
        // if there's nothing to scroll, hide the scrollbar
        if (this.totalHeight() <= this.height()) {
            this.parentScroll.hide("fade");
            this.content.css("marginTop", 0);
        } else { // otherwise, set the visibility to "visible" and shows it (the visibility was sent to "hidden" so it doesn't appear when loading the page)
            this.parentScroll.css("visibility", "visible");
            this.parentScroll.show("fade");
        }
        
        // calculate the size of the handle
        var halfHandleHeight = Math.round((this.height()/(this.totalHeight() / this.height())-this.difference)/2);
        
        // set the height of the scrollbar (it needs to be resized so the handle won't exceed the "parentScroll" div)
        // set the height of the handle and recalculate its middle
        this.scroll.height(this.scrollHeight()-(halfHandleHeight * 2)).find(".ui-slider-handle").height(
        halfHandleHeight * 2).css("margin-bottom",(-halfHandleHeight));
        
        // adapt the margin of the parentScroll so the handle fit well inside
        // resize the parentScroll so it doesn't become bigger than the content div
        this.parentScroll.css("paddingTop", halfHandleHeight).height(this.scrollHeight() - halfHandleHeight);
        
        // if there must be a slider, and the maxOffset is different from zero (to avoid a "divided by 0" error in the calculation below)
        // set the correct value to the slider, according to the negative margin of the content
        if (this.totalHeight() > this.height() && this.maxOffset()!=0) {
            var offset = this.content.css("marginTop").split("p")[0];
            this.scroll.slider("value", Math.round(100 * offset / this.maxOffset() + 100));
        }
    } // end of "resize"
} // end of slider